#define HIST_SIZE 500
#define ALI_SIZE 250
#define N_REGEXS 400
#define BORDER_DEFAULT_BEVEL 1
#define BORDER_DEFAULT_BORDER 2
#define BORDER_BEVEL_RAISED 4
#define BORDER_BEVEL_SUNKEN 8
#define BORDER_EDGE 16
#define BORDER_NO_EDGE 32
#define BORDER_NO_BEVEL 64

#include "pcre.h"
#include "pcrs.h"




class trie
{
public:
  trie (void)
  {

    for (int i = 0; i < 128; i++)
      this->ptrs[i] = NULL;
    this->val = NULL;
    this->n = 0;

  }

  int GetN (void)
  {

    return n;
  }
  void ReturnJoinedString (char *str, char *init)
  {
    char tmp[400];
    strcpy (tmp, init);

    if (val != NULL)
      {
        strcat (str, init);
        strcat (str, ": ");
        strcat (str, val);
        strcat (str, "\r\n");
      }
    for (int i = 0; i < 128; i++)
      {
        strcpy (tmp, init);
        char t[5];
        sprintf (t, "%c", i);
        strcat (tmp, t);

        if (ptrs[i] != NULL)

          ptrs[i]->ReturnJoinedString (str, tmp);


      }

  }
  char *GetString (char *str)
  {
    strlwr (str);
    return RecGetString (str);
  }
  char *RecGetString (char *str)
  {
    strlwr (str);
    if (*str)
      {
        if (*str >= 0 && *str < 128)
          if (this->ptrs[*str])
            return this->ptrs[*str]->GetString (str + 1);
          else
            return NULL;
        else
          return NULL;
      }
    else
      return this->val;

  }

  void AddString (char *str, char *val)
  {
    strlwr (str);
    RecAddString (str, val);
  }
  void RecAddString (char *str, char *val)
  {

    char c = *str;
    if (c)
      {
        if (c >= 0 && c < 128)
          {
           

            if (this->ptrs[c] == NULL)
              this->ptrs[c] = new trie;

            ptrs[c]->AddString (str + 1, val);
          }

      }
    else
      {
	//	  if (this->val != NULL)
     //     LocalFree (this->val);
        this->val = strdup (val);
        this->n++;
      }
  }



private:
  class trie * ptrs[128];
  char *val;
  int n;
};

class StrList;

class StrList
{
public:
  char *str;
  StrList *next;
  StrList *head;
  StrList(char *str)
  {
	this->str = str;
	next = NULL;
	this->head = this;
  }
  void AddElement(char *str)
  {
	    if(strlen(str)>1 && str[strlen(str)-1]=='\n')
			str[strlen(str)-1] = 0;
		StrList *nxt = new StrList(str);
		nxt->next = this;
		this->head = nxt;
  }

};

class Broambox
{
public:
  HWND hEditWnd;
  HWND hSlit;
  bool shown;
  StrList *RegexList;
  WNDPROC wpEditProc;
  void AddAlias (char *alias, char *expands);
  void AddVariable (char *var, char *expands);
  FILE *logfile;
  COLORREF textColor;
  bool useAutoHide;
  trie *AliasTrie;
  trie *VarTrie;
  char configStyle[MAX_LINE_LENGTH];
  HANDLE LastACHandle;
  void AutoCompletePath (char *path);
  void SetupVariables(void);
  void ReadAliases(void);
  void ReadHistory(void);
  void SetBevel(char *temp);
  void SaveSettings(void);
  void WritePosition(void);
  void ShowString(char *str);
  void ShowTrie(trie *tr);
  void ShowAliases();
  void ShowRegexs();
  void ShowVariables();
    Broambox (HINSTANCE, HWND);
  bool CreateBroambox ();
  void DestroyBroambox ();
  void PaintBroambox (HDC, LPRECT);
  void SizeBroambox ();
  void MoveBroambox (WINDOWPOS *);
  void AutoComplete (char *text);
  void ReadSettings ();
  void ReplaceFont ();

  pcre *var_match;
  pcre_extra *var_extra;
  pcre *urlre;
  pcre_extra *urlre_extra;
  int ParseVariable (char *varstr);
  char successSound[MAX_LINE_LENGTH];
  char failSound[MAX_LINE_LENGTH];
  void ShowWindow ();
  void ShowWindowAt (int x, int y);
  void HideWindow ();

  void EnterSlit ();
  void LeaveSlit ();
  void UpdateSlit ();
  bool InSlit ()
  {
    return (inSlit && (hSlit != NULL));
  }
  void ToggleSlitAutoHide (bool);

  void ToggleInSlit ()
  {
    if (hSlit == NULL)
      return;
    if (InSlit ())
      LeaveSlit ();
    else
      EnterSlit ();
  }
  void ExpandAlias (char *ret_val, char *alias_val, char *remaining,
                    char *args);
  void Execute ();
  void HistoryPrev ();
  void HistoryNext ();
  void ResetHistoryIndex ()
  {
    historyIndex = 0;
  }

  LRESULT LButtonDown (HWND, UINT, WPARAM, LPARAM);
  LRESULT RButtonDown (HWND, UINT, WPARAM, LPARAM);

  LPCSTR GetAppName ()
  {
    return "UberBox";
  }
  LPCSTR GetAppAuthor ()
  {
    return "John Williamson / Brian \"Tres`ni\" Hartvigsen";
  }
  LPCSTR GetAppEmail ()
  {
    return "johnhw@gmail.com";
  }
  LPCSTR GetAppLink ()
  {
    return "";
  }
  LPCSTR GetAppVersion ()
  {
    return "0.1.1";
  }
  LPCSTR GetAppRelease ()
  {
    return "21 Jan 2005";
  }
  HINSTANCE hMainInst;
  int x, y, width, height, bevel, border;
  void AutoCompleteNext (char *str, int istab);
  void AutoCompletePrev (char *str);
  void ExpandVariable (char *str, int len);
  void ExpandVariables (char *buf, char *args);
  void AutoCompleteReset ();
  void GetVarValue (char *varname, char *varvalue);
  void WriteAlias (char *name);
  char ModulePath[MAX_LINE_LENGTH];
  void Broambox::ParseEnvironmentVariables ();
  //      void SetTransparency(HWND hwnd);

  pcrs_job *regexs[N_REGEXS];

  int n_regex;
  char localDir[MAX_LINE_LENGTH];
  HWND hBB4Win;
  bool autoHideEverywhere;
  int borderStyle;
  int borderWidth;
  int bevelWidth;
  StyleItem *overStyle;

  bool use_regexs;
  
  bool regex_debug;
  bool inSlit;
private:
  void SetWinFont (HWND win, HFONT font);
  HFONT aliasFont;

  void reverseHistory ();
  int lastTabCompleteIndex;
  void ExpandRegexs (char *buf, char **out);
  void FindRegexs (char *regex);


  HFONT hEditFont;
  
  bool tempSlit;
  bool isSlitAutoHide;

  StyleItem *mainStyle;
  StyleItem *editStyle;

  Menu *mainMenu;

  COLORREF mainBackColor, mainBackColorTo;
  COLORREF editBackColor, editBackColorTo;
  COLORREF borderColor;
  bool no8Ball;
  bool noWho;

  char fontFace[MAX_PATH];
  int fontHeight;
  void ExpandAliases (char *buf, char *args);
  int historyIndex;
  int historyCount;
  char history[HIST_SIZE][500];

  int transparent;
  int alpha;

};
